#!/usr/bin/python
# $Id: execute.py,v 1.2 2003/11/13 14:51:05 hat Exp $
#
# Base classes for (remote) execution objects
#

class Exec_program:
    """Wrapper class for the Distributor object to hide the details of how a
       (remote) program is executed.
       After construction of the object, self.open() is called once, followed
       by a number of calls to self.can_compute() and/or self.compute(). Just
       before discarding the object, self.close() is called."""

    def __init__(self, hostname, id):
	self.hostname=hostname
	self.id=id

    def get_hostname(self): return self.hostname
    def get_id(self): return self.id

    def open(self):
	"Initialize"
	pass

    def can_compute(self,jobtype):
	"Can you compute a job of 'jobtype'?"
	return 0    # cannot compute

    def compute(self,jobtype,parms):
	raise "Cannot compute job"

    def close(self):
	"Shut down"
	pass


class Exec_program_factory:
    """Creates exec_program objects upon demand"""

    def __init__(self):
	pass

    def get_machines(self):
	"""Return a dictionary of jobtype : list of machines."""
	return {}   # no job-types

    def make_exec_program(self,jobtype,hostname,id):
	"""Create a exec_program object that can execute job on hostname.
	   Id is a unique number within this instance of Distributor.
	   Return an exec_program object or None if the factory cannot create
	   the object."""
	return None

