# $Id: log.py,v 1.1 2003/11/13 14:51:06 hat Exp $
#
import sys,time

class Log:
    """Class to log events.
       'typelist' is a list of event types to log, 'filename' is the name of
       the file to log to. stdout and stderr are recognized as special
       filenames. An empty list of event types log everything.

       The Log class does not prescribe the eventtypes, but one possible set is
       [ 'debug', 'info', 'progress', 'warning', 'error', 'serious', 'panic',
         'notused' ]."""

    def __init__(self,typelist,filename):
	self._fname=filename	# name of the file to log to
	self._tlist=typelist	# list of event types to log
	self._emptyline=1	# output an empty-line first

    def log(self,eventtype,eventtext):
	if self._tlist!=[] and eventtype not in self._tlist:
	    return  # Wrong eventtype, should not be logged

	now=time.ctime(time.time())
	line=now+', ('+eventtype+'):\t'+eventtext+'\n'
	if self._emptyline:
	    line='\n'+line
	    self._emptyline=0

	if self._fname=='stdout':
	    sys.stdout.write(line)
	elif self._fname=='stderr':
	    sys.stderr.write(line)
	else:
	    fp=open(self._fname,'a')	# a bit expensive, but safe.
	    fp.write(line)
	    fp.close()
